import 'dart:io';

import 'package:gaza_machine/src/base/machine.dart';
import 'package:gaza_machine/src/generated/grpc/machine.pbgrpc.dart';
import 'package:gaza_machine/src/generated/grpc/machine.pbgrpc.service.dart';
import 'package:grpc/grpc.dart';

class MachineClient extends MachineBase {
  final int _port;
  final String ip;
  MachineClient(this._port, [String? ip])
      : ip = ip ?? InternetAddress.anyIPv4.address;

  late final _channel = ClientChannel(
    ip,
    port: _port,
    options: ChannelOptions(
      credentials: ChannelCredentials.insecure(),
      codecRegistry:
          CodecRegistry(codecs: const [GzipCodec(), IdentityCodec()]),
    ),
  );

  @override
  late final BetterShellClientBase shell =
      BetterShellClient(ShellClient(_channel));

  @override
  late final BetterSystemClientBase system =
      BetterSystemClient(SystemClient(_channel));
}
