// ignore_for_file: implementation_imports

import 'dart:async';
import 'dart:io' as io;

import 'package:gaza_machine/src/generated/grpc/machine.pbgrpc.dart';
import 'package:gaza_machine/src/generated/grpc/machine.pbgrpc.service.dart';
import 'package:path/path.dart';

class SystemService extends BetterSystemServiceBase {
  String pMachineDir;
  SystemService(this.pMachineDir);

  @override
  Stream<EnviromentVariable> getEnviromentVariables(Empty request) async* {
    for (final variable in io.Platform.environment.entries) {
      yield EnviromentVariable(key: variable.key, value: variable.value);
    }
  }

  @override
  FutureOr<OSResponse> getOS(Empty request) {
    final OS os;
    if (io.Platform.isLinux) {
      os = OS.linux;
    } else if (io.Platform.isWindows) {
      os = OS.windows;
    } else if (io.Platform.isMacOS) {
      os = OS.macos;
    } else {
      os = OS.unknown;
    }
    return OSResponse(value: os);
  }

  @override
  Stream<FileSystemEntity> listDir(ListDirRequest request) async* {
    final dir = io.Directory(request.path);

    await for (final entity in dir.list()) {
      final statt = entity.statSync();

      final FileSystemEntityType type;
      if (statt.type == io.FileSystemEntityType.directory) {
        type = FileSystemEntityType.dir;
      } else if (statt.type == io.FileSystemEntityType.file) {
        type = FileSystemEntityType.file;
      } else {
        type = FileSystemEntityType.unknownType;
      }
      yield FileSystemEntity(type: type, name: dirname(entity.path));
    }
  }
}
